KNIFE-UPLOAD(1)

NAME
knife-upload - The man page for the knife upload subcommand.

The knife upload subcommand is used to upload roles, cookbooks, environments, and data bags to the Chef server from the current working directory in the chef-repo. This subcommand is often used in conjunction with knife diff, which can be used to see exactly what changes will be uploaded, and then knife download, which does the opposite of knife upload.

Syntax

This subcommand has the following syntax:

$ knife upload [PATTERN...] (options)

Options

This subcommand has the following options:

-c CONFIG_FILE, --config CONFIG_FILE
    The configuration file to use.

--chef-repo-path PATH
    The path to the chef-repo. This setting will override the default path to the chef-repo. Default: same as specified by chef_repo_path in config.rb.

--chef-zero-port PORT
    The port on which chef-zero will listen.

--[no-]color
    Use to view colored output.

--concurrency
    The number of allowed concurrent connections. Default: 10.

-d, --disable-editing
    Use to prevent the $EDITOR from being opened and to accept data as-is.

--defaults
    Use to have knife use the default value instead of asking a user to provide one.

--[no-]diff
    Use to upload only new and modified files. Set to false to upload all files. Default: true.

-e EDITOR, --editor EDITOR
    The $EDITOR that is used for all interactive commands.

-E ENVIRONMENT, --environment ENVIRONMENT
    The name of the environment. When this option is added to a command, the command will run only against the named environment.

-F FORMAT, --format FORMAT
    The output format: summary (default), text, json, yaml, and pp.

--[no-]force
    Use --force to upload roles, cookbooks, etc. even if the file in the directory is identical (by default, no POST or PUT is performed unless an actual change would be made). Default: --no-force.

--[no-]freeze
    Use to require changes to a cookbook be included as a new version. Only the --force option can override this setting. Default: false.

-h, --help
    Shows help for the command.

-k KEY, --key KEY
    The private key that knife will use to sign requests made by the API client to the Chef server.

-n, --dry-run
    Use to take no action and only print out results. Default: false.

--print-after
    Use to show data after a destructive operation.

--[no-]purge
    Use --purge to delete roles, cookbooks, etc. from the Chef server if their corresponding files do not exist in the chef-repo. By default, such objects are left alone and NOT purged. Default: --no-purge.

--[no-]recurse
    Use --no-recurse to disable uploading a directory recursively. Default: --recurse.

--repo-mode MODE
    The layout of the local chef-repo. Possible values: static, everything, or hosted_everything. Use static for just roles, environments, cookbooks, and data bags. By default, everything and hosted_everything are dynamically selected depending on the server type. Default: everything / hosted_everything.

-s URL, --server-url URL
    The URL for the Chef server.

-u USER, --user USER
    The user name used by knife to sign requests made by the API client to the Chef server. Authentication will fail if the user name does not match the private key.

-v, --version
    The version of the chef-client.

-V, --verbose
    Set for more verbose outputs. Use -VV for maximum verbosity.

-y, --yes
    Use to respond to all confirmation prompts with "Yes". knife will not ask for confirmation.

-z, --local-mode
    Use to run the chef-client in local mode. This allows all commands that work against the Chef server to also work against the local chef-repo.

    Examples

    Browse to the top level of the chef-repo and enter:

    $ knife upload

    or from anywhere in the chef-repo, enter:

    $ knife upload /

    Browse to the top level of the chef-repo and enter:

    $ knife upload cookbooks

    or from anywhere in the chef-repo, enter:

    $ knife upload /cookbooks

    Browse to the top level of the chef-repo and enter:

    $ knife upload environments

    or from anywhere in the chef-repo, enter:

    $ knife upload /environments

    Browse to the top level of the chef-repo and enter:

    $ knife upload environments/production.json

    or from the environments/ directory, enter:

    $ knife upload production.json

    Browse to the top level of the chef-repo and enter:

    $ knife upload roles

    or from anywhere in the chef-repo, enter:

    $ knife upload /roles

    Browse to the top level of the chef-repo and enter:

    $ knife upload cookbooks/apache\* roles/webserver.json

    $ knife upload `knife deps nodes/*.json`

AUTHOR
Chef